<template>
  <v-ons-page class="listArticle">
    <v-ons-toolbar modifier="transparent" class="home-toolbar">
      <div class="left">
        <v-ons-toolbar-button @click="$store.commit('splitter/toggle')">
          <v-ons-icon icon="ion-navicon, material:md-menu"></v-ons-icon>
        </v-ons-toolbar-button>
      </div>
      <div class="center">{{ msg }}</div>
    </v-ons-toolbar>

    <div class="wrapBtn">
      <div v-for="item in items" :key="item.id">
        <v-ons-card>
          <span>
            <span class="box">
              <div
                :class="{ boxDisabled: item.paid == true }"
                class=""
                @click="push(item.id)"
              >
                <div class="imageArticle">
                  <span v-html="getPostThumbnail(item.imageArticle)"></span>
                </div>
                <div class="textArticle">
                  <div class="title">
                    <h3>{{ item.title }}</h3>
                  </div>
                  <div class="info">
                    <h6>{{ item.createDate | formatDate }}</h6>
                    <div>
                      <span
                        class="tags"
                        v-for="xCat in item.category"
                        :key="xCat.name"
                        >{{ xCat.name }}</span
                      >
                    </div>
                  </div>

                  <h6 class="progressBox" v-if="item.quizId">
                    <v-ons-progress-bar :value="100">
                      <p>100%</p>
                    </v-ons-progress-bar>
                  </h6>
                </div>
                <div class="lockIcon" v-if="item.paid == true">
                  <i class="fa fa-lock" aria-hidden="true"></i>
                </div>
              </div>
            </span>
          </span>
        </v-ons-card>
      </div>
      <div v-if="isNoMore">
        <v-ons-card class="text-center">
          -- (Tidak ada materi lagi) --
        </v-ons-card>
      </div>

      <div v-if="isLoadMore">
        <v-ons-card class="text-center" @click="loadMore()">
          Selanjutnya
        </v-ons-card>
      </div>

      <div v-if="infinityScrollBool">
        <progress-circle class="postProgressCircle"></progress-circle>
      </div>
    </div>
  </v-ons-page>
</template>

<script>
import moment from "moment";
import { materiesCollection, auth } from "@/firebase";
import ProgressCircle from "@/components/ProgressCircle";
import FullPost from "@/components/Materies/FullPost.vue";

const fileStore = "";

export default {
  name: "MateriList",
  data() {
    return {
      msg: "Welcome",
      items: [],
      skipInt: 0,
      limitInt: 5,
      lastDoc: "",
      infinityScrollBool: true,
      isLoadMore: false,
      isSearching: false,
      isEmpty: false,
      isNoMore: false,
    };
  },
  components: {
    ProgressCircle,
  },
  created() {
    // this.isPaidUser();
    this.initData();
  },
  filters: {
    formatDate(val) {
      if (!val) {
        return "-";
      }
      let date = val.toDate();
      return moment(date).fromNow();
    },
  },
  methods: {
    isPaidUser() {
      let uid = auth.currentUser.uid;
      console.log(uid);
    },
    push(idPost) {
      this.$store.state.navigator.postId = "";
      this.$store.state.navigator.postId = idPost;

      this.$store.commit("navigator/push", FullPost);
    },
    getPostThumbnail(featuredImg) {
      if (featuredImg != undefined) {
        return (
          '<div class="thumbnail postFeaturedImg" style="background-image: url(' +
          fileStore.concat(featuredImg) +
          ');width: 100%;height: 45vw;"></div>'
        );
      } else {
        return (
          '<div class="thumbnail postFeaturedImg" style="background-image: url(' +
          fileStore +
          'no_entry_image.jpg)"></div>'
        );
      }
    },
    initData() {
      let that = this;

      const getMateries = materiesCollection
        .orderBy("createDate")
        .startAt(this.skipInt)
        .limit(this.limitInt);

      getMateries.get().then((snapshot) => {
        snapshot.forEach((doc) => {
          var lastVisible = snapshot.docs[snapshot.docs.length - 1];
          that.lastDoc = lastVisible;

          let post = doc.data();
          post.id = doc.id;

          that.items.push(post);
        });
        if (snapshot.size < this.limitInt) {
          that.infinityScrollBool = false;
          that.isLoadMore = false;
          that.isNoMore = true;
        } else {
          that.infinityScrollBool = false;
          that.isLoadMore = true;
          that.isNoMore = false;
        }
      });
    },
    loadMore() {
      let that = this;

      const getMateries = materiesCollection
        .orderBy("createDate")
        .startAfter(this.lastDoc)
        .limit(this.limitInt);

      getMateries.get().then((snapshot) => {
        snapshot.forEach((doc) => {
          var lastVisible = snapshot.docs[snapshot.docs.length - 1];
          that.lastDoc = lastVisible;

          let post = doc.data();
          post.id = doc.id;

          that.items.push(post);
        });

        if (snapshot.size < this.limitInt) {
          that.infinityScrollBool = false;
          that.isLoadMore = false;
          that.isNoMore = true;
        } else {
          that.infinityScrollBool = false;
          that.isLoadMore = true;
          that.isNoMore = false;
        }
      });
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.header {
  text-align: center;
  margin-top: 10%;
}

img {
  max-width: 300px;
}

ons-list-title {
  text-transform: none;
}

ons-list-title:not(:first-of-type) {
  margin-top: 30px;
}

ons-card {
  text-align: center;
}

ons-list-item,
ons-card {
  cursor: pointer;
}
</style>
